# 1 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
# 21 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
.equ NMICR, 0xfc40
.equ UNICR, 0xfc44
.equ ADB0, 0xfcd2
.equ ADB1, 0xfcd6
.equ ADBCTL, 0xfcda
.equ PBSWPL, 0xffbc
.equ UNID, (1<<0)
.equ ADB0CK, (1<<0)
.equ ADB1CK, (1<<1)
.equ ADB0ON, (1<<2)
.equ ADB1ON, (1<<3)


.equ irq_handler_vector, 0x804c
.equ irq_depth, 0x805b

.equ fake_command, 0xaa
.equ setoffset_command, 0x32
.equ readsector_command, 0xa8
.equ seeksector_command, 0xab
.equ enable_extensions_command, 0x55
.equ get_drive_status_command, 0xe0
.equ audiostream_command, 0xe1
.equ set_drive_status_command, 0xee
# 90 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
 .equ cmdbuf0, 0x80a8
 .equ drive_status, 0x81a4
 .equ drive_status2, 0x8188

 .equ bert, 0x8078
 .equ ernie, 0x8190
 .equ cactus, 0x40ed02

 .equ entry_return_address, 0x08d41e

 .equ data1, 0x008000
 .equ data1_size, 0x6e
 .equ data1_copy_from, 0x08e9c8

 .equ bss, 0x00806e
 .equ bss_size, 0x1ac

 .section absolute

 .org 0x0808aa
 initialize_drive:

 .org 0x082f2e
 memcpy:

 .org 0x082f50
 memset:

 .equ adb1_break_address, 0x089d42
 .org 0x089dd0
 adb1_fixup_exit:

 .equ adb0_break_address, 0x08b145
 .org 0x08b150
 adb0_fixup_exit:

 .equ disable_extensions_when_called_from, 0x0885b9
# 214 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
 .section .text
 .global _start
 .global _exit






_start:
_main:



 jsr initialize_drive


 mov data1, a0
 mov data1_copy_from, d1
 mov data1_size, d0
 jsr memcpy


 mov bss, a0
 sub d0, d0
 mov bss_size, d1
 jsr memset


 mov our_irq_handler, a0
 mov a0, (irq_handler_vector)


 mov adb1_break_address, a0
 mov a0, (ADB1)
 mov adb0_break_address, a0
 mov a0, (ADB0)


 mov ADB0ON, d0
 movb d0, (ADBCTL)


 mov entry_return_address, a0
 jmp (a0)

our_irq_handler:

 mov (ADBCTL), d0
 and ADB0CK, d0
 beq 1f
 jmp adb0_break_handler

1: sub d0,d0
 mov 0x40EC00, a0
 movb d0, (0x02, a0)
 movb d0, (0x03, a0)
 movb d0, (0x04, a0)
 movb d0, (0x05, a0)
 movb d0, (0x06, a0)
 movb d0, (0x07, a0)
 movb d0, (0x08, a0)
 movb d0, (0x09, a0)
 movb d0, (0x0a, a0)
 movb d0, (0x0b, a0)
 movb d0, (0x0c, a0)
 movb d0, (0x0d, a0)


 mov (ADBCTL), d0
 and ADB1CK, d0
 beq 2f
 jmp adb1_break_handler

2: mov cactus, a0
 mov 2, d0
 bset d0, (a0)


 mov (bert), d0
 mov d0, (ernie)


 mov cmdbuf0, a0
 movbu (0, a0), d0
 movb d0, (saved_cmdbuf0)


 mov fake_command, d0
 movb d0, (a0)


 mov (saved_irq_handler), a0
 jsr (a0)


 mov cmdbuf0, a0
 movbu (0, a0), d0
 cmp fake_command, d0
 bne extra_command_parser


 movb (saved_cmdbuf0), d0
 movb d0, (a0)

 rts

extra_command_parser:

 cmp setoffset_command,d0
 beq setoffset


 cmp readsector_command,d0
 beq handle_offsetpatching


 cmp seeksector_command,d0
 beq handle_offsetpatching


 cmp audiostream_command,d0
 beq handle_offsetpatching


 cmp set_drive_status_command, d0
 beq set_drive_status


 cmp enable_extensions_command, d0
 beq set_extensions

 rts

setoffset:
 mov (4, a0), a1
 jsr pointer_swap
 mov a1, (gcmoffset)
 sub d0,d0
 movb d0, (0, a0)
 rts

handle_offsetpatching:
 mov a2, d1
 mov (gcmoffset), a2
 mov (4, a0), a1
 jsr pointer_swap
 add a2, a1
 jsr pointer_swap
 mov a1, (4, a0)
 mov d1, a2
 rts

pointer_swap:
 mov a1,(PBSWPL)
 mov (PBSWPL),a1
 rts

set_extensions:


 movbu (cmdbuf0+1), d0
 jsr di_enable_or_disable_extensions
 bra 1f

set_drive_status:
 movbu (cmdbuf0+1), d0
 movb d0, (drive_status)
 movbu (cmdbuf0+2), d0
 movb d0, (drive_status2)

1: mov cmdbuf0, a0
 mov get_drive_status_command, d0
 movb d0, (a0)
 sub d0, d0
 movb d0, (1, a0)
 movb d0, (2, a0)
 movb d0, (3, a0)
 rts
# 426 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
adb0_break_handler:

 movbu (ADBCTL), d0
 and ~ADB0CK, d0
 movb d0, (ADBCTL)
 movbu (UNICR), d0
 and ~UNID, d0
 movb d0, (UNICR)


 mov a3, a0
 add 4, a0





 movbu (irq_depth), d0
 cmp 1, d0
 bne 1f
 mov (4, a3), a0


1: mov adb0_fixup, a1
 mov a1, (0x20, a0)
# 460 "e:/GameCube/sources/libogc/dvd_patchcodes/driveMG_all.S"
 mov (0x34, a0), a1
 cmp disable_extensions_when_called_from, a1
 bne 3f

di_disable_extensions:
 mov 0, d0

di_enable_or_disable_extensions:

 movbu (ADBCTL), d1
 and ~ADB1ON, d1
 cmp 0, d0
 beq 2f
 or ADB1ON, d1

2: movb d1, (ADBCTL)
 mov enable_extensions, a1
 movb d0, (a1)

3: rts

di_enable_extensions:
 mov 1, d0
 jmp di_enable_or_disable_extensions

adb0_fixup:

 and 0xf7ff, psw
 mov (a0), d1

 cmp 0x0608, d1
 bne 1f
 mov 2, d1
 movb d1, (1, a0)

1: mov (a0), d1
 cmp 0x00f000, d1
 bne 2f
 mov 0x00, d0
 movbu (enable_extensions), d1
 cmp 0, d1
 beq 2f
 movb d0, (0x09, a0)


2: mov (a0), d1
 cmp 0x06, d1
 bne 4f
 mov (0x06, a0), d1
 movbu (enable_extensions), d0
 cmp 0, d0
 beq 3f
 add 6, d1
3: mov d1, (0x06, a0)
4: jmp adb0_fixup_exit


adb1_break_handler:

 movbu (ADBCTL), d0
 and ~ADB1CK, d0
 movb d0, (ADBCTL)
 movbu (UNICR), d0
 and ~UNID, d0
 movb d0, (UNICR)


 mov a3, a0
 add 4, a0





 movbu (irq_depth), d0
 cmp 1, d0
 bne 1f
 mov (4, a3), a0


1: mov adb1_fixup, a1
 mov a1, (0x20, a0)

 rts

adb1_fixup:

 jmp adb1_fixup_exit


 .align 2
saved_irq_handler:

 .long 0x00080A74



enable_extensions:
 .byte 0x01
saved_cmdbuf0:
 .byte 0x00

 .align 4
gcmoffset:
 .long 0x00

_exit:
